defmodule ClickHouse.Format do
  @moduledoc """
  A behaviour to implement data formatting of ClickHouse queries and results.
  """

  @callback decode(result :: ClickHouse.Result.t()) ::
              {:ok, ClickHouse.Result.t()} | {:error, ClickHouse.FormatError.t()}

  @callback encode(query :: ClickHouse.Query.t()) ::
              {:ok, ClickHouse.Query.t()} | {:error, ClickHouse.FormatError.t()}
end
